package de.hdm_stuttgart.mi.sd1;

/**
 * Beginner's way of implementing the »X-mas tree« exercise.
 */
public class Xmas {

    public static void main(String[] args) {

        // Example: 6 rows, tree's body loop index ranging from 0 to 5

        //           X            The tree's top.
        //  0        *
        //  1       ***
        //  2      *****
        //  3     *******         The tree's body.
        //  4    *********
        //  5   ***********
        //          III           The tree's two bottom trunk lines.
        //          III

        final int numberOfRows = 6;                   // You may easily change this value.

        // Part one: The tree's top
        //
        for (int x = 0; x < numberOfRows - 1; x++) {   // Printing the tree's top. We need
            System.out.print(' ');                     // numberOfRows preceeding spaces for
        }                                              // indentation before printing the
        System.out.println("X");                       // 'X' (top) character.

        // Part two: The tree's body
        //
        for (int row = 0; row < numberOfRows ; row++) {    // Outer row per line loop
            // tree's body.

            for (int x = 0; x < numberOfRows - row - 1;x++) {  // Starting each line with
                System.out.print(' ');                     // (numberOfRows - row)
            }                                              // space characters ...

            for (int x = 0; x < 2 * row + 1; x ++) {       // .. then printing (2*row+1)
                // asterisks ('*') characters ...
                System.out.print('*');                     // (May try  '▲' instead)
            }
            System.out.print("\n");                        // ... and finally terminating the
        }                                                  // current body row.

        // Part three: The tree's bottom trunk
        //
        for (int x = 0; x < numberOfRows - 2; x++) {         // Indenting the first
            System.out.print(' ');                         // bottom trunk line ...
        }
        System.out.println("###");                         // ... finishing print.

        for (int x = 0; x < numberOfRows - 2; x++) {         // Indenting the second
            System.out.print(' ');                         // bottom trunk line
        }
        System.out.println("###");                         // ... finishing print.
    }
}
